/**
 * Common Functions for Balances Module
 */
(function() {
	/*Function to Table Row for Monthly Income Estimate Page*/
	ingrs.balances.createMonthlyIncomeEstimateTableRow = function(_args) {
		var initialMonthlyEstimate = _args.monthlyIncomeEstimate;
		
		var accountBalance = _args.accountBalance;

		var row = Titanium.UI.createTableViewRow();

		var container = Ti.UI.createView( {
			layout : 'vertical',
			top : 0,
			left : '3.1%',//'5%',
			right : '3.1%',
			height : 300
		});

		var horizontalContainer = Ti.UI.createView( {
			layout : 'horizontal',
			top : 0,
			left : 5,
			right : 0,
			height : 50
		});

		var estimatedMonthlyIncomeLabel = Titanium.UI.createLabel( {
			top : 5,
			height : 'auto',
			left : 0,// 15
			width : 'auto',
			text : initialMonthlyEstimate,
			color : '#ff7c00',
			font : {
				fontSize : 35,
				fontFamily : 'Helvetica Neue',
				fontWeight : 'bold'
			}
		});

		var perMonthLabel = Titanium.UI.createLabel( {
			top : 20,
			height : 'auto',
			width : 'auto',
			text : ' /month',
			color : '#ff7c00',
			font : {
				fontSize : 20,
				fontFamily : 'Helvetica Neue',
				fontWeight : 'bold'
			}
		});
		horizontalContainer.add(estimatedMonthlyIncomeLabel);
		horizontalContainer.add(perMonthLabel);

		var accountBalanceLabel = Titanium.UI.createLabel( {
			top : 15,
			height : 'auto',
			left : 0,
			right : 0,
			width : 'auto',
			color : '#363636',
			text : L('Label_MoIncome_AccBalanceText') + ' ' + accountBalance + '.',
			font : {
				fontSize : 15,
				fontFamily : 'Helvetica Neue'
			}
		});

		var assumptionsLabel = Titanium.UI.createLabel( {
			top : 15,
			height : 'auto',
			left : 0,
			right : 0,
			width : 'auto',
			color : '#363636',
			text : L('Label_MoIncome_Description'),
			font : {
				fontSize : 15,
				fontFamily : 'Helvetica Neue'
			}
		});

		container.add(horizontalContainer);
		container.add(accountBalanceLabel);
		container.add(assumptionsLabel);
		row.add(container);
		row.height = 'auto';
		return row;

	}; 

	/*Function to create Title Labels*/
	ingrs.balances.createCustomRowTitleLabel = function(_label) {
		var label = Titanium.UI.createLabel( {
			top : 12,
			height : 40,
			left : '10%',
			width : 'auto',
			color : '#363636',
			text : _label,

			font : {
				fontfamily : 'Helvetica Neue',
				fontSize : 12.5,
				fontWeight : 'bold'
			}
		});
		if(ingrs.isAndroid()){
			label.left = '3.0%';
			label.right='12%';
			label.width = '89%';
		}
		return label;
	};

	/*Function to create Value Labels*/
	ingrs.balances.createCustomRowValueLabel = function(_value) {

		var label = Titanium.UI.createLabel( {
			top : 40,
			height : 40,
			left : '10%',
			width : 'auto',
			text : _value,
			color : '#ff7c00',
			font : {
				fontfamily : 'Helvetica Neue',
				fontSize : 25,
				fontWeight : 'bold'
			}

		});
			if(ingrs.isAndroid()){
			label.left= '2%'
			
		}
		return label;

	};

	/*Function to create Vertical Line for Separation*/
	ingrs.balances.createVerticalDivLine = function(_height, _left) {

		var verticalLineView = Titanium.UI.createView( {
			top : 0,
			backgroundImage : '/images/bodycontent/div_line_verticle.png',
			left : _left,
			height : _height,
			width : 2
		});
		return verticalLineView;
	};
})();