(function() {

	/* Variables that will be accessed across JS files */
	var prrFlag = null, monthlyIncomeFlag = null, balBySourceFlag = null, vestingFlag = null, prrData = null, balanceSummaryData = null, monthlyIncomeData = null, fundBalanceData = null;
	var srcVestBalanceData = null, fundSrcBalanceData = null, currBalance = null;

	/***********************************************************************
	 * Function that creates Balances Summary Page
	 *
	 * @param :_response(returned
	 *            from server)
	 * @returns: Table View with Balance Summary Data
	 **********************************************************************/

	ingrs.balances.createBalanceTableViewDS = function(_response) {

		var molIncomeValueLabel, prrTitleLabel, molIncomeTitleLabel, molIncomeView, prrView, prrValueLabel, molIncomeImg, prrImg, verticalDivLine;
		Titanium.API.debug("In createBalanceTableViewDS function");
		Titanium.API.debug("Function Params _response::" + _response);

		/* Set the response in balanceSummaryData */
		ingrs.balances.setBalanceSummaryData(_response);

		/* create datasource to populate tableview */
		var datasource = [];

		/* Create Table View Rows */

		/* Row 1: Holds Current Balance Data */
		var row1 = Titanium.UI.createTableViewRow();

		var currBalTitleLabel = Titanium.UI.createLabel({

			left : '5%',
			top : 15,
			height : 17,
			width : 'auto',
			color : '#363636',
			text : L('Label_Current_Balance'),
			font : {
				fontfamily : 'Helvetica Neue',
				fontSize : 14,
				fontWeight : 'bold'
			}
		});
		currBalance = _response.currentBal;
		/* Set Current Balance */
		currBalanceValueLabel = Titanium.UI.createLabel({
			top : 30,
			height : 40,
			left : '5%',
			width : 'auto',
			text : "$" + _response.currentBal,
			color : '#ff7c00',
			font : {
				fontfamily : 'Helvetica Neue',
				fontSize : 35,
				fontWeight : 'bold'
			}
		});

		/* Set As of Date */
		dateLabel = Titanium.UI.createLabel({
			top : 54,
			height : 50,
			left : '5%',
			width : 'auto',
			text : "AS OF " + _response.asOfDate,
			color : '#a1a1a1',
			font : {
				fontfamily : 'Helvetica Neue',
				fontSize : 10,
				fontWeight : 'bold'
			}
		});

		row1.add(currBalTitleLabel);
		row1.add(currBalanceValueLabel);
		row1.add(dateLabel);
		row1.hasChild = false;
		row1.height = 93;
		row1.backgroundColor = '#FFFFFF';
		datasource.push(row1);

		/* Row 1: Ends */

		/* Row 2: Holds PRR and EstimatedMonthly Income Data */

		/* Flags that Control PRR and Monthly Income Display */
		prrFlag = 'Y'//_response.prrDisplayFlag;
		monthlyIncomeFlag = _response.monthlyIncomeDisplayFlag;

		row2 = Titanium.UI.createTableViewRow();
		if(ingrs.isAndroid()) {
			molIncomeImg = Titanium.UI.createView(styles.rightArrowImageAndroid);
			prrImg = Titanium.UI.createView(styles.rightArrowImageAndroid);

			/* Create view to hold PRR/MI Labels and Images */
			molIncomeView = Titanium.UI.createView({
				width : '47%',
				left : '3.5%',
				right : '46%',
				top : 0

			});

			/* Vertical Line dividing the row into two columns */
			verticalDivLine = ingrs.balances.createVerticalDivLine(87, '54%');

			prrView = Titanium.UI.createView({
				width : '42.75%',
				left : '57%',
				right : '0%',
				top : 0
			});

		} else {

			molIncomeView = Titanium.UI.createView({
				width : '48%',
				left : 0
			});
			prrView = Titanium.UI.createView({
				width : '42.75%',
				left : '53.25%'
			});
			verticalDivLine = ingrs.balances.createVerticalDivLine(87, '52%');
			molIncomeImg = Titanium.UI.createView(styles.rightArrowImage);
			prrImg = Titanium.UI.createView(styles.rightArrowImage);

		}

		if(monthlyIncomeFlag !== 'N' && _response.molIncome !== null && _response.molIncome !== undefined && _response.molIncome !== "<null>") {
			molIncomeTitleLabel = ingrs.balances.createCustomRowTitleLabel(L('Label_Monthly_Income'));
			var moIncomeEstimate = _response.molIncome;
			var tempIncomeEstimate = moIncomeEstimate;
			if(tempIncomeEstimate[1] === '00') {
				moIncomeEstimate = tempIncomeEstimate[0];
			}

			molIncomeValueLabel = ingrs.balances.createCustomRowValueLabel(moIncomeEstimate);
			/* Add Labels and Images for Monthly Income to the View */
			molIncomeView.add(molIncomeTitleLabel);
			molIncomeView.add(molIncomeValueLabel);

		}

		if(prrFlag !== 'N' && _response.personalRateofReturn !== null && _response.personalRateofReturn !== undefined && _response.personalRateofReturn !== "<null>") {
			prrTitleLabel = ingrs.balances.createCustomRowTitleLabel(L('Label_Personal_Rate'));
			prrTitleLabel.height = 34;
			prrValueLabel = ingrs.balances.createCustomRowValueLabel(_response.personalRateofReturn + "%");
			/* Add Labels and Images for PRR to the View */
			prrView.add(prrTitleLabel);
			prrView.add(prrValueLabel);

		}
		row2.height = 87;

		/*
		 * Check flag values to display PRR/Monthly Income data on the Summary
		 * Page
		 */

		if((prrFlag === 'Y') & (monthlyIncomeFlag === 'N')) {
			if(ingrs.isAndroid()) {
				prrImg.top = 20;
				prrImg.right = '0%';
				prrView.right = '3%';
			} else {
				prrImg.top = 30;
				prrImg.right = '4%';
				prrView.right = '0%';
			}
			prrValueLabel.top = 35;
			prrTitleLabel.top = 12;
			prrTitleLabel.left = '0%';
			prrValueLabel.left = '0%';
			prrView.left = '5%';
			prrView.width = '95%';
			prrView.right = '2%';
			prrView.add(prrImg);
			row2.add(prrView);
			row2.backgroundColor = '#FFFFFF';
			datasource.push(row2);
		}
		/* Display only Monthly Income data */
		else if((monthlyIncomeFlag === 'Y') & (prrFlag === 'N')) {
			if(ingrs.isAndroid()) {
				molIncomeImg.top = 20;
				molIncomeImg.right = '0%';
				molIncomeView.right = '3%';
			} else {
				molIncomeImg.top = 31;
				molIncomeImg.right = '4%';
				molIncomeView.right = '0%';
			}

			molIncomeTitleLabel.left = '0%';
			molIncomeTitleLabel.top = 12;
			molIncomeValueLabel.left = '0%';
			molIncomeValueLabel.top = 35;
			molIncomeView.left = '5%';
			molIncomeView.width = '95%';
			molIncomeView.add(molIncomeImg);

			row2.add(molIncomeView);
			row2.backgroundColor = '#FFFFFF';
			datasource.push(row2);

		}
		/* Display only PRR and Monthly Income data */
		else if((monthlyIncomeFlag === 'Y') & (prrFlag === 'Y')) {

			molIncomeView.add(molIncomeImg);
			row2.add(molIncomeView);
			row2.add(verticalDivLine);
			prrView.add(prrImg);
			row2.add(prrView);
			row2.backgroundColor = '#FFFFFF';
			datasource.push(row2);

		}

		/*
		 * Image View Event Listener for Monthly Income.Called when arrow
		 * image is clicked
		 */
		molIncomeView.addEventListener('click', function(e) {

			var miData = ingrs.balances.getMIData();

			ingrs.balances.displayMonthlyIncomePage(miData);

		});

		/* Image View Event Listener for PRR.Called when arrow image is clicked */
		prrView.addEventListener('click', function(e) {
			var prrData = ingrs.balances.getPRRData();
			ingrs.balances.displayPRRPage(prrData);
		});

		/* Row 2: Ends */

		/* Row 3: Holds Balance History Graph */
		if((_response.displayBalanceHistoryGraph === 'Y') && (_response.balanceHistoryDataList !== null && _response.balanceHistoryDataList.length !== 0)) {
			var balanceGraph = ingrs.balances.createBarGraph(_response);
			var row3 = Titanium.UI.createTableViewRow();
			row3.backgroundColor = '#FFFFFF';
			row3.height = 230;
			row3.add(balanceGraph);
			datasource.push(row3);
		}
		/* Row 3: Ends */

		/* Row 4: Holds Balance by Fund */
			var balByFundFlag = 'Y'//_response.balByFundFlag;
		 if(balByFundFlag === 'Y'){
		 var row4 =createBalancesMenuRow('Balance By Fund','images/icons/icon_balances_fund_off.png');
		 row4.hasChild=true;
		 row4.childWin='Balance By Fund';
		 datasource.push(row4);
		 }

		/* Row 4: ends */

		/* Row 5:Holds Personal Rate of Return */
		if(prrFlag === 'Y') {
			var row5 = createBalancesMenuRow('Personal Rate of Return', '/images/icons/icon_arrow_off.png');
			row5.hasChild = true;
			row5.childWin ='Personal Rate of Return';
			datasource.push(row5);
		}
		/* Row 5: ends */

		/* Row 6: Holds Estimated Monthly Income */
		if(monthlyIncomeFlag === 'Y') {
			var row6 = createBalancesMenuRow('Estimated Monthly Income', '/images/icons/icon_monthly_income_on.png');
			row6.childWin = 'Estimated Monthly Income';
			datasource.push(row6);
		}

		/* Row 6 :ends */

		/* Row 7: Holds Vested Balance by Source */
		//	var balBySourceFlag = _response.balBySourceFlag;
		/*	if(balBySourceFlag === 'Y'){
		 var row7 = createBalancesMenuRow(L('Label_Balances_By_Source'),'images/icons/icon_vested_off.png');
		 row7.hasChild=true;
		 row7.childWin=L('Label_Balances_By_Source');
		 datasource.push(row7);
		 }*/

		/* Row 7 :ends */

		/* Row 8: Holds Balance by vesting */
		/*var vestingFlag = _response.vestingFlag;
		 if(vestingFlag === 'Y'){
		 var row8 = createBalancesMenuRow(L('Label_Balances_By_Vest'),'images/icons/icon_vesting_off.png');
		 row8.hasChild=true;
		 row8.childWin=L('Label_Balances_By_Vest');
		 datasource.push(row8);
		 }*/

		/* Row 8 :ends */
		return datasource;

	};

	/*******************************************************************************
	 * Function that creates Balances History Graph
	 *
	 * @param :_response
	 * @returns: View with Balance Graph
	 ******************************************************************************/

	ingrs.balances.createBarGraph = function(_response) {

		Titanium.API.debug("In createBarGraph function");

		var container = Ti.UI.createView({
			layout : 'vertical',
			top : 0,
			left : '5%',
			right : '3.1%'
		});

		container.add(Titanium.UI.createLabel({
			left : 0,
			top : 18,
			font : {
				fontFamily : 'Helvetica Neue',
				fontSize : 12.5,
				fontWeight : 'bold',

			},
			color : '#363636',
			text : L('Label_Balance_History'),
			width : 'auto',
			height : 'auto'

		}));

		var balanceDataList = {}, i = 0, amtArray = new Array();
		if(_response.balanceHistoryDataList !== null && _response.balanceHistoryDataList !== 'undefined') {
			balanceHistoryListSize = _response.balanceHistoryDataList.length - 1;
			Titanium.API.debug("Balance History Data List size::" + balanceHistoryListSize);

			for( i = balanceHistoryListSize; i >= 0; i--) {

				Titanium.API.debug("Label::********" + _response.balanceHistoryDataList[i].year);

				Titanium.API.debug("Percent::********" + _response.balanceHistoryDataList[i].balance);

				Titanium.API.debug("Value::******" + _response.balanceHistoryDataList[i].percent);

				balanceDataList[i] = _response.balanceHistoryDataList[i];
				/*
				 * Remove $ and ',' from Balance Amount to create an array which will be
				 * sorted to get the Maximum Balance
				 */
				amtArray.push(_response.balanceHistoryDataList[i].balance.replace("$", "").replace(",", ""));

			}

			Titanium.API.debug("Amount Array List::" + amtArray.toString());

			var sortedArray = [];
			/* Sort Array to the highest Balance */
			sortedArray = amtArray.sort(function(a, b) {
				return a - b
			})
			/* Get Max Amount form the Array */
			var maxAmt = sortedArray[sortedArray.length - 1];

			Titanium.API.debug("Max Amount::" + maxAmt);

			for(var key in balanceDataList) {
				Titanium.API.debug("Values in iMap are" + key + " : " + balanceDataList[key]);
				var view = Titanium.UI.createView({
					left : 0
				});
				var viewBack = Titanium.UI.createView(styles.ViewBackground);
				var mainView = Titanium.UI.createView(styles.mainView);
				var labelvalue = Titanium.UI.createLabel(styles.LabelValue);
				var label = Titanium.UI.createLabel(styles.Label);
				viewBack.add(view);
				viewBack.add(labelvalue);
				mainView.add(label);
				mainView.add(viewBack);
				container.add(mainView);
				label.text = balanceDataList[key].year;
				labelvalue.text = balanceDataList[key].balance;

				/* if Amount is not 0,set view color and calculate view width */
				if((balanceDataList[key].balance !== '$0') && (balanceDataList[key].balance !== '$0.00')) {
					if(key == balanceHistoryListSize) {
						view.backgroundColor = '#FF7C00';
					} else {
						view.backgroundColor = '#999999';
					}
					// view.width=getPercentageWidth(balanceDataList[key].balance,maxAmt);
					view.width = balanceDataList[key].percent;

				}

			}
		}

		/**
		 * Function that calculates width of a view with respect to the highest Balance
		 * Amount
		 *
		 * @param :_value -
		 *            Balance Amount
		 * @param :_maxAmt -
		 *            Highest Balance
		 * @returns: width
		 */
		function getPercentageWidth(_value, _maxAmt) {
			var width = (parseFloat(_value.replace("$", "").replace(",", "")) / parseFloat(_maxAmt)) * 100 + "%";
			Titanium.API.debug("getPercentageWidth called" + width);

			return width;
		};

		return container;

	};

	/**
	 * Function that sets Balance Summary Page Data
	 *
	 * @returns: void
	 */
	ingrs.balances.setBalanceSummaryData = function(_response) {

		balanceSummaryData = _response;

	};

	/**
	 * Function that gets Balance Summary Page Data
	 *
	 * @returns: balanceSummaryData
	 */
	ingrs.balances.getBalanceSummaryData = function() {
		return balanceSummaryData;
	};

	/**
	 * Function that gets PRR data
	 *
	 * @returns: prrData
	 */
	ingrs.balances.getPRRData = function() {
		return prrData;

	};

	/**
	 * Function that sets PRR data
	 *
	 * @returns: void
	 */
	ingrs.balances.setPRRData = function(_prrData) {
		prrData = _prrData;

	};

	/**
	 * Function that gets PRR data
	 *
	 * @returns: prrData
	 */
	ingrs.balances.getFundBalanceData = function() {
		return fundBalanceData;

	};

	/**
	 * Function that sets PRR data
	 *
	 * @returns: void
	 */
	ingrs.balances.setFundBalanceData = function(_fundBalanceData) {
		fundBalanceData = _fundBalanceData;

	};

	/**
	 * Function that gets fund source data
	 *
	 * @returns: prrData
	 */
	ingrs.balances.getFundSrcBalanceData = function() {
		return fundSrcBalanceData;

	};

	/**
	 * Function that sets fund source data
	 *
	 * @returns: void
	 */
	ingrs.balances.setFundSrcBalanceData = function(_fundSrcBalanceData) {
		fundSrcBalanceData = _fundSrcBalanceData;

	};

	/**
	 * Function that gets fund source data
	 *
	 * @returns: prrData
	 */
	ingrs.balances.getSrcVestBalanceData = function() {
		return srcVestBalanceData;

	};

	/**
	 * Function that sets fund source data
	 *
	 * @returns: void
	 */
	ingrs.balances.setSrcVestBalanceData = function(_srcVestBalanceData) {
		srcVestBalanceData = _srcVestBalanceData;

	};

	/**
	 * Function that sets MI data
	 *
	 * @returns: void
	 */
	ingrs.balances.setMIData = function(_miData) {
		monthlyIncomeData = _miData;

	};
	/**
	 * Function that gets MI data
	 *
	 * @returns: monthlyIncomeData
	 */
	ingrs.balances.getMIData = function() {
		return monthlyIncomeData;

	};

	/**
	 * Function that gets the Personal Rate of Return data from Server
	 *
	 * @returns: void
	 */
	ingrs.balances.getPRRDatafromServer = function() {

		Titanium.API.debug("In getPRRDatafromServer function");
		ingrs.net.httpCall({
			url : '/epweb/mobile/MblPersonalPerf.action',
			method : 'GET',
			/*
			 * CallBack Function to process Response returned from the
			 * server
			 */
			cb : function(_prrData) {
				Titanium.API.debug("Response received from getPRRDatafromServer::" + _prrData);
				if(_prrData !== null) {
					var prrWindow = ingrs.balances.createRateOfReturnWindow(_prrData);
					ingrs.balances.setPRRData(_prrData);
					ingrs.UI.openChildWindow(prrWindow);

				}
			}
		});

	};

	ingrs.balances.getBalancesByFund = function() {

		Titanium.API.debug("In getBalancesByFund function");
		ingrs.net.httpCall({
			url : '/epweb/mobile/MblBalanceByFund.action',
			method : 'GET',
			/*
			 * CallBack Function to process Response returned from the server
			 */
			cb : function(_fundBalanceData) {
				Titanium.API.debug("Response received from getBalancesByFund::" + _fundBalanceData);
				if(_fundBalanceData !== null) {
					var bbfWindow = ingrs.balances.createBalanceByFundWindowMain(_fundBalanceData);
					ingrs.balances.setFundBalanceData(_fundBalanceData);
					ingrs.UI.openChildWindow(bbfWindow);
				}
			}
		});

	};

	ingrs.balances.getBalancesBySource = function() {

		Titanium.API.debug("In getBalancesBySource function");
		ingrs.net.httpCall({
			url : '/epweb/mobile/MblBalanceBySrc.action',
			method : 'GET',
			/*
			 * CallBack Function to process Response returned from the server
			 */
			cb : function(_fundSrcBalanceData) {
				Titanium.API.debug("Response received from getBalancesBySource::" + _fundSrcBalanceData);
				if(_fundSrcBalanceData !== null) {
					var bbfWindow = ingrs.balances.createBalanceBySourceWindowMain(_fundSrcBalanceData);
					ingrs.balances.setFundSrcBalanceData(_fundSrcBalanceData);
					ingrs.UI.openChildWindow(bbfWindow);
				}
			}
		});

	};

	ingrs.balances.getBalancesByVest = function() {

		Titanium.API.debug("In getBalancesByVest function");
		ingrs.net.httpCall({
			url : '/epweb/mobile/MblBalanceByVest.action',
			method : 'GET',
			/*
			 * CallBack Function to process Response returned from the server
			 */
			cb : function(_srcVestBalanceData) {
				Titanium.API.debug("Response received from getBalancesByVest::" + _srcVestBalanceData);
				if(_srcVestBalanceData !== null) {
					var bbfWindow = ingrs.balances.createBalanceByVestWindowMain(_srcVestBalanceData);
					ingrs.balances.setSrcVestBalanceData(_srcVestBalanceData);
					ingrs.UI.openChildWindow(bbfWindow);
				}
			}
		});

	};

	/**
	 * Function that gets the Estimated Monthly Income data from Server
	 *
	 * @returns: void
	 */
	ingrs.balances.getMonthlyIncomeDatafromServer = function() {

		ingrs.net.httpCall({
			url : '/epweb/mobile/mblMonthlyRetirementEstimate.action',
			method : 'GET',
			/*
			 * CallBack Function to process Response returned from
			 * the server
			 */
			cb : function(_miData) {
				Titanium.API.debug("Response received from getMonthlyIncomeDatafromServer::" + _miData);
				if(_miData !== null) {
					var miWindow = ingrs.balances.createMonthlyIncomeEstimateWindow(_miData);
					ingrs.balances.setMIData(_miData);
					ingrs.UI.openChildWindow(miWindow);
				}
			}
		});

	};

	/**
	 * Function that constructs the PRR Page
	 *
	 * @returns: void
	 */
	ingrs.balances.displayPRRPage = function(_prrData) {

		if(_prrData === null) {
			Titanium.API.debug("In displayPRRPage function making http call  for  _prrData ::" + _prrData);
			ingrs.balances.getPRRDatafromServer();
		} else {

			var prrWindow = ingrs.balances.createRateOfReturnWindow(_prrData);
			Titanium.API.debug("In displayPRRPage function _prrData::" + _prrData);
			ingrs.UI.openChildWindow(prrWindow);

		}

	};

	/**
	 * Function that constructs the Monthly Income Page
	 *
	 * @returns: void
	 */
	ingrs.balances.displayMonthlyIncomePage = function(_miData) {

		if(_miData === null) {
			Titanium.API.debug("In displayMonthlyIncomePage function making http call for  _miData ::" + _miData);
			ingrs.balances.getMonthlyIncomeDatafromServer();
		} else {
			var miWindow = ingrs.balances.createMonthlyIncomeEstimateWindow(_miData);
			Titanium.API.debug("In displayMonthlyIncomePage function _miData::" + _miData);
			ingrs.UI.openChildWindow(miWindow);

		}

	};

	/**
	 * Function that constructs the PRR Page
	 *
	 * @returns: void
	 */
	ingrs.balances.displayBalanceByFundPage = function(_fundBalanceData) {

		if(_fundBalanceData === null) {
			Titanium.API.debug("In displayBalanceByFundPage function making http call for _fundBalanceData ::" + _fundBalanceData);
			ingrs.balances.getBalancesByFund();
		} else {
			var bbfWindow = ingrs.balances.createBalanceByFundWindowMain(_fundBalanceData);
			ingrs.UI.openChildWindow(bbfWindow);

		}

	};

	/**
	 * Function that constructs the PRR Page
	 *
	 * @returns: void
	 */
	ingrs.balances.displayBalanceBySrcPage = function(_fundSrcBalanceData) {

		if(_fundSrcBalanceData === null) {
			Titanium.API.debug("In displayBalanceBySrcPage function making http call for _fundSrcBalanceData ::" + _fundSrcBalanceData);
			ingrs.balances.getBalancesBySource();
		} else {
			var bbfWindow = ingrs.balances.createBalanceBySourceWindowMain(_fundSrcBalanceData);
			ingrs.UI.openChildWindow(bbfWindow);

		}

	};

	/**
	 * Function that constructs the PRR Page
	 *
	 * @returns: void
	 */
	ingrs.balances.displayBalanceByVestPage = function(_srcVestBalanceData) {

		if(_srcVestBalanceData === null) {
			Titanium.API.debug("In displayBalanceByVestPage function making http call for src vest data ::" + _srcVestBalanceData);
			ingrs.balances.getBalancesByVest();
		} else {
			var bbfWindow = ingrs.balances.createBalanceByVestWindowMain(_srcVestBalanceData);
			ingrs.UI.openChildWindow(bbfWindow);

		}

	};

	/**
	 * Function that creates Balances Menu Rows
	 *
	 * @returns: table row
	 */
	function createBalancesMenuRow(_label, _leftImage) {
		var row = Titanium.UI.createTableViewRow({
			backgroundColor : '#FFFFFF'
		});
		var rowLabel = Titanium.UI.createLabel({
			top : 0,
			left : '12.5%',
			width : 'auto',
			color : '#363636',
			text : _label,
			height : 42,
			font : {
				fontSize : 14,
				fontWeight : 'bold',
				fontFamily : 'Helvetica Neue'
			}
		});
		if(ingrs.isAndroid()) {
			rowLabel.height = 50;
		}
		row.leftImage = _leftImage;
		row.add(rowLabel);
		row.hasChild = true;

		return row;
	};
	ingrs.balances.resetBalancesSummaryData = function() {
		prrFlag = null;
		monthlyIncomeFlag = null;
		prrData = null;
		balanceSummaryData = null;
		monthlyIncomeData = null;
		fundBalanceData = null;
		srcVestBalanceData = null;
		fundSrcBalanceData = null;
		vestingFlag = null;
		balBySourceFlag = null;
		currBalance = null;
	};
})();

