(function() {
	/*******************************************************************************
	 * Self Calling Function that creates Main Balances Summary Window
	 * @param : _response from server        
	 * @returns: window with Balance Summary Data
	 ******************************************************************************/

	ingrs.balances.createBalancesWindow = function(_response) {
		var genericTableView,iOSTopTitle,planText,navTitleText,menuTitle,winLeftNavButton,winRightNavButton,winBackButtonTitle,
		winBackButtonTitle,winBackButtonTitleImage,winTabBarHidden,tableViewDS,subHeader,win;

		Titanium.API.debug("In createBalancesWindow function");
		Titanium.API.debug("Function Params _response::" + _response);
			
		/* Get Company Name,Plan Name,Page Title and NavBar Title */
		iOSTopTitle = ingrs.globalData.company;
		planText = ingrs.globalData.plan;

		navTitleText = L('Label_Balance_Summary');
		menuTitle = L('Label_Balances');

		/* buttons: ... note: set to blank string if not used */
		winLeftNavButton =ingrs.UI.leftNavEmptyView();
		winRightNavButton = ingrs.UI.NavLogoutButton();
		winBackButtonTitle = '';
		winBackButtonTitleImage = '';

		/* properties */
		winTabBarHidden = false;

		/* Create Page Subheader */
		subHeader = ingrs.UI.createDefaultSubHeader(navTitleText, planText,
		menuTitle);

		/* Create Balance Summary Table View */
		tableViewDS = ingrs.balances.createBalanceTableViewDS(_response);

		genericTableView = ingrs.UI.buildDefaultTableView(tableViewDS);
		genericTableView.backgroundColor='#e7e7e7';

		/*
		 * Table View Event Listener to Open child windows on Balance Summary
		 * Page
		 */
		genericTableView.addEventListener('click', function(e) {
			
			if (e.row.childWin) {
				var childWindow;

				if (e.row.childWin === 'Personal Rate of Return') {
					genericTableView.touchEnabled = false;
					Titanium.API.debug("Getting PRR data");
					//var prrData = ingrs.balances.getPRRData();
					//ingrs.balances.displayPRRPage(prrData);
					var landscapeWin = ingrs.UI.openWinInLandscape();
					// landscapeWin.open();
					ingrs.UI.openChildWindow(landscapeWin);
					// ingrs.UI.openChildWindow(Ti.UI.createWindow({
						// backgroundColor:'blue',
						// fullscreen:false,
						// title:'Joooooon'
					// }));

				} else if (e.row.childWin === 'Estimated Monthly Income') {
					genericTableView.touchEnabled = false;
					/*Titanium.API.debug("Getting MI data");
					var miData = ingrs.balances.getMIData();
					ingrs.balances.displayMonthlyIncomePage(miData);*/
					
					ingrs.util.openPDF("The_iPad_App_Wave.pdf", "http://www.appcelerator.com/assets/The_iPad_App_Wave.pdf",'Test',true);

				}
				 else if (e.row.childWin === 'Balance By Fund') {
					genericTableView.touchEnabled = false;
					var client = Ti.Network.createHTTPClient({
     	
    			 onload : function(e) {
     				var bWin = ingrs.UI.balanceByFundWin();
     				ingrs.UI.openChildWindow(bWin);
    			 },
     			// function called when an error occurs, including a timeout
    			 onerror : function(e) {
     			//	hideActivityIndicator()
   				  }
 				});
 // Prepare the connection.
 client.open("GET", "http://www.appcelerator.com");
 // Send the request.
 client.send();
					
				}
				 else if (e.row.childWin === L('Label_Balances_By_Source')) {
					genericTableView.touchEnabled = false;
					var fbd=ingrs.balances.getFundSrcBalanceData();
					ingrs.balances.displayBalanceBySrcPage(fbd);
				}
				 else if (e.row.childWin === L('Label_Balances_By_Vest')) {
					 genericTableView.touchEnabled = false;
						var fbd=ingrs.balances.getSrcVestBalanceData();
						ingrs.balances.displayBalanceByVestPage(fbd);
				}
				

			}
		});
		/* assign header and footer to tableview */
	//	genericTableView.footerView = ingrs.UI.createApplicationFooterView();

		/*
		 * create window parms:
		 * _contentView,,_winTitle,_winTabBarHidden,_winLeftNavButton,_winRightNavButton,_winBackButtonTitle,_winBackButtonTitleImage
		 */
		win = ingrs.UI.buildDefaultWindow(genericTableView, iOSTopTitle,
		winTabBarHidden, winLeftNavButton, winRightNavButton,
		winBackButtonTitle, winBackButtonTitleImage);
		win.innerContainer.add(subHeader);
		win.innerContainer.offset += subHeader.height;
		win.menuMainWindow=true;
		win.addEventListener('focus', function(e) {
		win.orientationModes = [
     Titanium.UI.PORTRAIT,
     Titanium.UI.LANDSCAPE_LEFT,
     Titanium.UI.LANDSCAPE_RIGHT
 ];
			genericTableView.touchEnabled = true;
		});
		
		Ti.App.addEventListener('setOrientationMode', function(e) {
			win.orientationModes = [Titanium.UI.PORTRAIT, Titanium.UI.LANDSCAPE_LEFT, Titanium.UI.LANDSCAPE_RIGHT];
			loginWin.orientationModes = [Titanium.UI.PORTRAIT, Titanium.UI.LANDSCAPE_LEFT, Titanium.UI.LANDSCAPE_RIGHT];
		});
			
		return win;

	}; /* end ingrs.UI.createBalancesWindow function */
})();