(function() {

	/*******************************************************************************
	 * Self Calling Function that creates the top Subheader
	 * @param :  _navTitleText,_planText,_menuTitle
	 * @returns: subheader view
	 ******************************************************************************/
	ingrs.UI.createDefaultSubHeader = function(_navTitleText, _planText,
	_menuTitle,_asOfDate) {

		Titanium.API.debug("In createDefaultSubHeader function");
		Titanium.API
		.debug("Function Params _navTitleText,_planText,_menuTitle::"
		+ _navTitleText + _planText + _menuTitle);

		var nonBottomLineHeight = 70;
		var bottomLineHeight = 8;
		var containerHeight = (nonBottomLineHeight + bottomLineHeight);

		var verticalDivLine = Titanium.UI.createView({
			top : 0,
			backgroundImage : '/images/bodycontent/div_line_verticle.png',
			height :70,
			width : 2,
			donotscale : true,
			right :36,
			position:'last'
		});

		var container = Titanium.UI.createView({
			layout : 'vertical',
			left : 0,
			height : containerHeight
		});
		if(ingrs.isAndroid()) {
			container.top = 40;
		} else {
			container.top = 0;
		}

		var subNavView = Titanium.UI.createView({
			top : 0,
			left : 0,
			right:0,
			height : containerHeight,
			backgroundColor : '#e1e1e1'
		});

		var subNavTitleView = Titanium.UI.createView({
			top : 0,
			position:'first',
			left:'0%',
			isLeftPercent:'true',
			height : nonBottomLineHeight,
			width : 280,
			backgroundColor : '#e1e1e1'
		});

		var menuImgView = Titanium.UI.createView({

			top : 0,
			position:'last',
			right:0,
			isRightPercent : true,
			height:70,
			width :'12%',
			isPercent : true

		});

		var imageColView = Titanium.UI.createImageView({
			top : 28,
			image : '/images/arrows/arrows_down.png',
			width : 13,
			height : 9,
			donotscale:'true',
			position:'last',
			right:13

		});

		var cancelButton=ingrs.UI.NavCancelButton();
		menuImgView.add(imageColView);

		/* if blank menu title passed in then don't add menu */
		if (_menuTitle !== "") {

			menuImgView.addEventListener(
			'click', function(e) {

				var menuWindow = Titanium.UI.createWindow({
					barColor : '#929292',
					title : _menuTitle,
					backgroundColor : '#E7E7E7',
					leftNavButton:ingrs.UI.leftNavEmptyView(),
					rightNavButton : cancelButton

				});
				menuWindow.addEventListener('focus', function(e) {
					Ti.App.fireEvent('enableTouchOnBalancesMenuWindow');
					Ti.App.fireEvent('enableTouchOnSubMenuWindow');
				});
				var menuBarView =ingrs.UI.createWindowHeaderforAndroid(menuWindow,_menuTitle,'Y','','',cancelButton);
				cancelButton.addEventListener('click', function(e) {
					if(ingrs.isAndroid()){
					ingrs.UI.closeAllWindowsTillMain(Ti.API._activeTab, {
					menuMainWindow : true
				});
				}else{
					menuWindow.close();
				}
		
				});
				switch (_menuTitle) {
					case L('Label_Balances'):

						Titanium.API
						.debug("Creatung Balances Menu");
						var balancesData = ingrs.balances
						.getBalanceSummaryData();
						var prrFlag = balancesData.prrDisplayFlag;
						var monthlyIncomeFlag = balancesData.monthlyIncomeDisplayFlag;
						var balBySourceFlag = balancesData.balBySourceFlag;
						var vestingFlag = balancesData.vestingFlag;
						var currBalance = balancesData.currentBal;
						var balByFundFlag = 'N';
						if(typeof currBalance !== 'undefined' && currBalance !== null && parseInt(currBalance) > 0){
							balByFundFlag = 'Y';
						}
						var view=ingrs.balances
						.createBalancesMenu(
						_planText, prrFlag,
						monthlyIncomeFlag,balBySourceFlag,vestingFlag,balByFundFlag);
						if(ingrs.isAndroid()) {

							view.add(menuBarView);
						
							
						}
						menuWindow.add(view);
						menuBarView.addEventListener('click', function(e) {

						});
						break;
					case L('Label_Contributions'):
						var contributionsMenuView = ingrs.contributions.createContributionMenu(_planText);
						if(ingrs.isAndroid()) {
							contributionsMenuView.add(menuBarView);
						}
						menuWindow.add(contributionsMenuView);
						menuBarView.addEventListener('click', function(e) {});
						break;
					case L('Label_Investments'):
					var investmentsMenuView = ingrs.investments.createInvestmentsMenu(_planText);
						if(ingrs.isAndroid()) {

							investmentsMenuView.add(menuBarView);
						
						}
						menuWindow.add(investmentsMenuView);
						menuBarView.addEventListener('click', function(e) {});
						break;
					case L('Label_More'):
					var moreMenuView = ingrs.more.createMoreMenu(_planText);
					if(ingrs.isAndroid()) {

							moreMenuView.add(menuBarView);
						
							
					}
					menuWindow.add(moreMenuView);
					menuBarView.addEventListener('click', function(e) {});
					break;
					default:

						break;
				}

				ingrs.UI.openChildWindow(menuWindow);
			});
		}

		var subNavViewBottomLine = Titanium.UI.createView({
			top : nonBottomLineHeight,
			height : 8,
			position:'first',
			left:'0%',
			isLeftPercent:'true',
			backgroundColor : '#ff7c00'
		});

		var subNavViewPlanLabel = Titanium.UI.createLabel({
			top : 10,
			height : 35,
			left:'5%',
			isLeftPercent:'true',		
			width:258,	
			color : '#363636',
			text : _planText,
			shadowColor : '#ffffff',
			shadowOffset : {
				x : 1,
				y : 1
			},
			font : {
				fontfamily : 'Helvetica Neue',
				fontSize : 12,
				fontWeight : 'regular'
			}
		});

		var subNavViewSectionTitleLabel = Titanium.UI.createLabel({

			height : 'auto',	
			left:'5%',
			top:38,
			width:'100%',
			position:'first',
			color : '#363636',
			text : _navTitleText,
			shadowColor : '#ffffff',
			shadowOffset : {
				x : 1,
				y : 1
			},
			font : {
				fontfamily : 'Helvetica Neue',
				fontSize : 20,
				fontWeight : 'bold'
			}
		});
		if(ingrs.isAndroid()){
		if (_planText.length > 40) {
		    		subNavViewPlanLabel.text=_planText.substring(0,40)+'...';
				}
			}else{
				if (_planText.length > 40) {
					subNavViewSectionTitleLabel.top=40;	
				}
			}
		
		
		if(_navTitleText !== 'undefined' && _navTitleText === L('More_Disclosure_Info')){
			subNavViewPlanLabel.left = '3%';
			subNavViewSectionTitleLabel.left = '3%';
			verticalDivLine.right = 32;
			subNavViewSectionTitleLabel.font = {
				fontfamily : 'Helvetica Neue',
				fontSize : 19,
				fontWeight : 'bold'
			}
		}
	
		if(typeof _asOfDate !== 'undefined' && _asOfDate !== null){
			var subNavViewSectionAsOfDateLabel = Titanium.UI.createLabel({
			height : 15,
			left:'5%',
			top:66,
			width:150,
			position:'first',
			isLeftPercent:'true',
			color : '#a1a1a1',
			text : 'AS OF ' + (_asOfDate).toUpperCase(),
			shadowColor : '#ffffff',
			shadowOffset : {
				x : 1,
				y : 1
			},
			font : {
				fontfamily : 'Helvetica Neue',
				fontSize : 9,
				fontWeight : 'bold'
			}
		});
		
		subNavView.add(subNavViewSectionAsOfDateLabel);
		menuImgView.top = 5;
		subNavViewPlanLabel.top = 10;
		verticalDivLine.height = 92;
		subNavViewBottomLine.top = 84;
		container.height = 92;
		subNavView.height = 92;

		}
		
		
		subNavTitleView.add(subNavViewPlanLabel);
		subNavTitleView.add(subNavViewSectionTitleLabel);
		subNavView.add(subNavTitleView);
		subNavView.add(verticalDivLine);
		subNavView.add(menuImgView);
		subNavView.add(subNavViewBottomLine);
		container.add(subNavView);

		return container;

	}; /* end ingrs.UI.createDefaultNavMenu function */
	
	
	/*******************************************************************************
	 * Self Calling Function that creates the top Subheader for change contributions
	 * @param :  _headerText,_subText       
	 * @returns: subheader view
	 ******************************************************************************/
	ingrs.UI.createChangeContributionsSubHeader=function(_headerText,_subText) {
		
		var subNavViewSectionTitleLabel = Titanium.UI.createLabel({
			top:15,
			height:35,
			left:'5%',
			color:'#363636',
			text:_headerText,
			shadowColor:'#ffffff',
			shadowOffset: {
				x:1,
				y:1
			},
			font: {
				fontfamily:'Helvetica Neue',
				fontSize:20,
				fontWeight:'bold'
			}
		});
		var subNavViewSubTextLabel = Titanium.UI.createLabel({
			top:30,
			height:80,
			left:'5%',
			right:'5%',
			color:'#363636',
			text:_subText,
			shadowColor:'#ffffff',
			shadowOffset: {
				x:1,
				y:1
			},
			font: {
				fontfamily:'Helvetica Neue',
				fontSize:14,
				fontWeight:'regular'
			}
		});
		var subNavViewBottomLine = Titanium.UI.createView({
			top:100,
			height:8,
			backgroundColor:'#ff7c00'
		});
		var container = Titanium.UI.createView({
			top:0,
			height:108,
			backgroundColor:'#e1e1e1'
		});
		if (ingrs.isAndroid()) {
			container.top = 45;
		}
		container.add(subNavViewSectionTitleLabel);
		container.add(subNavViewSubTextLabel);
		container.add(subNavViewBottomLine)
		return container;
	}; // end ingrs.UI.createChangeContributionsSubHeader
	

	/*******************************************************************************
	 * Self Calling Function that creates the top Subheader for change contributions
	 * @param :  _headerText,_subText       
	 * @returns: subheader view
	 ******************************************************************************/
	ingrs.UI.createInvestmentsPendingTransactionSubHeader=function(_headerText,_subText) {
		
		var nonBottomLineHeight=105;
		var bottomLineHeight=8;
		var containerHeight=(nonBottomLineHeight+bottomLineHeight);

		var container = Titanium.UI.createView({
			layout:'vertical',
			top:0,
			left:0,
			height:containerHeight
		});
		
		if(ingrs.isAndroid()) {
			container.top = 40;
		} else {
			container.top = 0;
		}

		var subNavView = Titanium.UI.createView({
			top:0,
			left:0,
			height:containerHeight,
			backgroundColor:'#e1e1e1'
		});

		var subNavTitleView = Titanium.UI.createView({
			top:0,
			left:0,
			right:0,
			height:nonBottomLineHeight,
			backgroundColor:'#e1e1e1'
		});
		
		var subNavViewBottomLine = Titanium.UI.createView({
			top:nonBottomLineHeight,
			height:8,
			backgroundColor:'#ff7c00'
		});
		
		/* title text.. big letters */
		var subNavViewSectionTitleLabel = Titanium.UI.createLabel({
			top:18,
			height:35,
			left:'5%',
			right:'5%',
			color:'#363636',
			text:_headerText,
			shadowColor:'#ffffff',
			shadowOffset: {
				x:1,
				y:1
			},
			font: {
				fontfamily:'Helvetica Neue',
				fontSize:20,
				fontWeight:'bold'
			}
		});
		
		/* sub text, smaller letters */
		var subNavViewSubTextLabel = Titanium.UI.createLabel({
			top:45,
			height:50,
			left:'5%',//'10dp',
			color:'#363636',
			text:_subText,
			shadowColor:'#ffffff',
			shadowOffset: {
				x:1,
				y:1
			},
			font: {
				fontfamily:'Helvetica Neue',
				fontSize:14,
				fontWeight:'regular'
			}
		});

		subNavTitleView.add(subNavViewSubTextLabel);
		subNavTitleView.add(subNavViewSectionTitleLabel);
		subNavView.add(subNavTitleView);
		subNavView.add(subNavViewBottomLine);
		container.add(subNavView);
		
		return container;
		
	}; /* end ingrs.UI.createInvestmentsPendingTransactionSubHeader */

	
})();