
(function() {
	
	ingrs.UI.buildDefaultTableView=function(_datasource,_asOfDate) 
	{
		/* create tableview based on tableviewrow datasource */
		var tableView = Titanium.UI.createTableView({
			data:_datasource,
			scrollable:true
		});
		if(ingrs.isAndroid()) {
			tableView.top = 73;
		}else{
			tableView.top = 78;
		}
		/* Moving the tableview further down if the subheader as 'asOfDate' */
		if(typeof _asOfDate !== 'undefined' && _asOfDate !== null){
			tableView.top += 14;
		}
		
		return tableView;
		
	}; /* end buildDefaultTableView2 function */
	
	ingrs.UI.buildDefaultWindow=function(_contentView,_winTitle,_winTabBarHidden,
		_winLeftNavButton,_winRightNavButton,_winBackButtonTitle,_winBackButtonTitleImage,_transactionWin) 
	{
		var win;
		/* create window and set most properties */
		if(ingrs.isAndroid()){

			var b = false;
			if(_transactionWin===true){		
				b=true;
				win = Titanium.UI.createWindow({
					backgroundColor:'white',
					barColor:'#ff7b01',
					tabBarHidden:_winTabBarHidden,
					top:0,
					navBarHidden:b
				});
			}
			else{
				win = Titanium.UI.createWindow({
					backgroundColor:'white',
					barColor:'#ff7b01',
					tabBarHidden:_winTabBarHidden,
					// fullscreen:false
					// Fede here is where they are reporting the issue - setting navBarHidden creates a heavyweight
					// navBarHidden:b    
				});
			}

		}
		else{
			 win = Titanium.UI.createWindow({
				//title:_winTitle,
				backgroundColor:'white',
				barColor:'#ff7b01',
				tabBarHidden:_winTabBarHidden,
				navBarHidden:ingrs.isAndroid(), // RJG 2011-07-22
				top:0
			});
			
		}
	
		
		if(_winRightNavButton.title === L('Label_Cancel_Button') ||  _winRightNavButton.title === L('Label_Done_Button')){
			win.barColor = '#929292';
	    }
		/* since these properties can override each other, set them separately */
		var innerContainer = Ti.UI.createView({top:0});
		win.innerContainer = innerContainer;
		if(ingrs.isAndroid()) {
			_winBackButtonTitle = '';
			innerContainer.add(ingrs.UI.createWindowHeaderforAndroid(win,ingrs.globalData.company,ingrs.globalData.headerType, _winBackButtonTitle,_winLeftNavButton,_winRightNavButton,_winTitle,_transactionWin));	
		} else {
			/* do ios title bar stuff */
			if (_winLeftNavButton !== "") {
				win.leftNavButton = _winLeftNavButton;
			}
			if (_winRightNavButton !== "") {
				win.rightNavButton = _winRightNavButton;
			}
			if (_winBackButtonTitle !== "") {
				win.backButtonTitle = _winBackButtonTitle;
			}
			if (_winBackButtonTitleImage !== "") {
				win.backButtonTitleImage = _winBackButtonTitleImage;
			}
			//add the title bar
			var titleBar = ingrs.UI.getTitleBar(ingrs.globalData.company, ingrs.globalData.headerType,_winTitle,_transactionWin);
			win.titleControl =titleBar;
		
		} /* end if */
		
		
		/* create container to space for potential droid title bar */
		var container = Ti.UI.createView({
			top:ingrs.android.droidTitleBarHeight,
			left:0,
			right:0
		});

		/* add contentview to container and container to window */
		container.add(_contentView);
		innerContainer.add(container);
		if(ingrs.isAndroid()) {
			/** http://jira.appcelerator.org/browse/TIMOB-4219 **/
			innerContainer.offset = ingrs.android.droidTitleBarHeight;
			win.addEventListener('doubletap',function() {
				if(typeof innerContainer.fullScreen === 'undefined') {
					innerContainer.fullScreen = true;
				}
				if(innerContainer.fullScreen === true){
					if(Ti.Gesture.orientation !== Ti.UI.PORTRAIT && Ti.Gesture.orientation !== Ti.UI.UPSIDE_PORTRAIT) {
						innerContainer.fullScreen = false;
						innerContainer.top = 0 - innerContainer.offset;
					}
				}
				else{	
					innerContainer.fullScreen = true;
					innerContainer.top = 0;
				}
			});
		}
		else {
			innerContainer.offset = 0;
		}
		win.add(innerContainer);
		/*if(typeof _contentView.footerView === 'undefined'){
			Ti.API.debug("footer added not added .. adding now");		
			var fView = ingrs.UI.createApplicationFooterView();
			win.add(fView);
		}*/

		return win;
		
	}; /* end buildDefaultWindow function */
	ingrs.UI.getTitleBar = function(_titleName, _headerType, _winTitle,_transactionWin){
		Ti.API.debug("Adding the title bar"+_headerType);
		
		var titleView = Titanium.UI.createView({
			top:0,
			left:0,
			height:45			
		});
		/* Replacing the header with the window title if it is a transaction window */
		if(typeof _transactionWin !== 'undefined' && _transactionWin !== null && _transactionWin != ''){
			_headerType = null;
			_titleName = _winTitle;
		}
		
		
		if(typeof _headerType !== 'undefined' && _headerType !== null && _headerType.trim != ''){
			if(_headerType === 'I'){
				var titleImage = Ti.UI.createImageView({
					width:94,
					height:24,
					opacity:1,
					image:'/images/header/ing_logo_header.png',
					anchorPoint:{y:0.5,x:0.5}
				});
				titleView.add(titleImage);
			}else if(_headerType === 'Y'){
				var titleLabel = Titanium.UI.createLabel({
					color:'#FFFFFF',
					text:_titleName,
					textAlign:'center',
					top:10,
					height:'auto',
					width:'auto',
					backgroundColor:'transparent',
					font:{fontSize:18,fontWeight:'bold'}
				});
				titleView.add(titleLabel);
			}else {
				//suppress
			}
		}else{
			var titleLabel = Titanium.UI.createLabel({
					color:'#FFFFFF',
					text:_titleName,
					textAlign:'center',
					top:10,
					height:25,//'auto',
					width:300,//'auto',
					backgroundColor:'transparent',
					font:{fontSize:18,fontWeight:'bold'}
				});
				titleView.add(titleLabel);
		}
		
		
		return titleView;
	};
	
	/* Changes the appearance of the window based on the orientation */
	ingrs.UI.orientationChange = function(_win,_genericTableView,_currOrientation) {
		if(_currOrientation === 'landscape') {
					if (ingrs.isIphone()) {
						_win.hideNavBar();
					}
					Ti.App.fireEvent('hideTabGroup');
					_genericTableView.footerView.hide();
					_win.innerContainer.top = 0 - _win.innerContainer.offset;

				} else {
					if (ingrs.isIphone()) {
						_win.showNavBar();
					}
					Ti.App.fireEvent('showTabGroup');
					_genericTableView.footerView.show();
					_win.innerContainer.top = 0;
				}
	};
	
	ingrs.UI.getOrientation = function getOrientation(o) {
		switch (o) {
			case Titanium.UI.PORTRAIT:
				return 'portrait';
			case Titanium.UI.UPSIDE_PORTRAIT:
				return 'portrait';
			case Titanium.UI.LANDSCAPE_LEFT:
				return 'landscape';
			case Titanium.UI.LANDSCAPE_RIGHT:
				return 'landscape';
		}
	};
	
	
})();