(function() {

	/* cssession id created after successful login. */
	ingrs.auth.cssessionid = null;

	/* clientId of the participant after successful login. */
	ingrs.auth.selectedClient = null;

	/* contact no of client */
	ingrs.auth.clientInformationLine = null;

	ingrs.auth.createLoginWindow = function() {
		var navGroup, prefWindow;
		var scrollView = Titanium.UI.createScrollView({
			contentWidth : 'auto',
			contentHeight : 'auto',
			top : 0,
			showVerticalScrollIndicator : true,
			showHorizontalScrollIndicator : true,
			layout : 'vertical'
		});

		if(ingrs.isIphone()) {

			var loginWindow = Ti.UI.createWindow({
				navBarHidden : true,
			});

			var modalWin = Ti.UI.createWindow({
				title : L('Label_Back_Button'),
				backgroundColor : '#E7E7E7',
				exitOnClose : true,
				navBarHidden : true
			});
			navGroup = Ti.UI.iPhone.createNavigationGroup({
				window : modalWin
			});
			Ti.App.addEventListener('closeNavigationGroup', function(e) {
				navGroup.close(prefWindow);

			})
			modalWin.add(scrollView);
			
		} else {
			var loginWindow = Titanium.UI.createWindow({
				title : 'Login',
				exitOnClose : true,
				backgroundColor : '#E7E7E7',
			});
			loginWindow.add(scrollView);
		}

		/* label ends*/
		var loginHeader = ingrs.auth.ui.createLoginHeader();

		loginHeader.addEventListener('click', function() {
			ingrs.auth.blurFields();
		});

		scrollView.add(loginHeader);

		/* preference starts */

		/* create table view */
		var loginPrefView = ingrs.auth.ui.createCustomTableView({
			top : 15,
			height : 132
		});

		var prefRow = ingrs.auth.ui.createCustomRowView({
			_showEndLine : true
		});

		var prefRowL1 = ingrs.auth.ui.createLabel({
			left : '3.1%',
			text : L('Login_Title'),
			color : '#363636'
		});

		var prefRowL2 = ingrs.auth.ui.createPrefLabel('Username');

		prefRowL2.textid = 'UNAME';

		var prefArrow = Ti.UI.createImageView({
			width : 9,
			height : 13,
			image : '/images/arrows/arrow_table_cell.png',
			anchorPoint : {
				y : 0.5
			},
			right : '4%'
		});

		prefRow.add(prefRowL1);
		prefRow.add(prefRowL2);
		prefRow.add(prefArrow);

		prefRow.addEventListener('click', function() {
			userTypeValue.blur();
			passwdValue.blur();
			/* to update pref values when its changed */
			function updatePref(param) {
				prefRowL2.text = param.loginDisplay;
				userTypeValue.hintText = param.loginDisplay;
				userTypeValue.keyboardType = param.keyboard;
				prefRowL2.textid = param.serverValue;
				userTypeValue.passwordMask = param.mask;
				userTypeValue.value = '';
				userTypeMask.text = '';
				passwdValue.value = '';
				/* removing the toolbar if the login type is Username */
				if(param.loginDisplay === 'Username') {
					userTypeValue.keyboardToolbar = null;
					userTypeValue.keyboardToolbarColor = null;
					userTypeValue.keyboardToolbarHeight = null;
				} else {
					userTypeValue.keyboardToolbar = param.keyboardToolbar;
					userTypeValue.keyboardToolbarColor = param.keyboardToolbarColor;
					userTypeValue.keyboardToolbarHeight = param.keyboardToolbarHeight;
				}
				if(prefRowL2.textid === 'SSN') {
					rememberSwitch.value = false;
					rememberSwitch.enabled = false;
				} else {
					rememberSwitch.enabled = true;
				}
			}

			if(ingrs.isAndroid()) {
				ingrs.auth.loginPref.createWindow(prefRowL2.text, updatePref).open();
			} else {
				//	ingrs.auth.loginPref.createWindow(prefRowL2.text,updatePref).open({modal:true});
				/*On iOS Navigation group is specifically used to get the Back Button with 'Bezel Border'*/
				prefWindow = ingrs.auth.loginPref.createWindow(prefRowL2.text, updatePref);
				navGroup.open(prefWindow, {
					animated : true
				});
			}

		});
		ingrs.auth.ui.done.addEventListener('click', function(e) {
			userTypeValue.blur();
		})

		loginPrefView.add(prefRow);

		/* preference ends */

		/* ssn / passwd starts */

		/* ssn starts */
		var userTypeRow = ingrs.auth.ui.createCustomRowView({
			_showEndLine : true
		});

		var userTypeValue = ingrs.auth.ui.createtextField({
			keyboard : Ti.UI.KEYBOARD_DEFAULT,
			password : true,
			hintText : 'Username'
		});
		var userTypeMask = ingrs.auth.ui.createMaskLabel();

		userTypeValue.addEventListener('return', function() {
			userTypeValue.blur();
		});
		userTypeValue.addEventListener('change', function(e) {
			Ti.API.info('User Id changed:' + e.source.value);
			if(prefRowL2.textid === 'SSN')
				return;

			var tmp = e.source.value;
			if(tmp.length > 4) {
				tmp = tmp.substring(0, 4);
			}
			userTypeMask.text = tmp;
		});
		userTypeRow.add(userTypeValue);
		userTypeRow.add(userTypeMask);

		userTypeRow.addEventListener('click', function() {
			userTypeValue.focus();
		});

		loginPrefView.add(userTypeRow);

		/* ssn ends */

		/* passwd starts */
		var passwdRow = ingrs.auth.ui.createCustomRowView({
			_showEndLine : false
		});

		var passwdValue = ingrs.auth.ui.createtextField({
			keyboard : Ti.UI.KEYBOARD_ASCII,
			password : true,
			hintText : 'Password'
		});

		passwdValue.addEventListener('return', function() {
			passwdValue.blur();
		});
		Ti.App.addEventListener('app:invalidLogin', function() {
			passwdValue.value = '';
		});
		Ti.App.addEventListener('app:endSession', function() {
			passwdValue.value = '';
		});

		passwdRow.add(passwdValue);

		loginPrefView.add(passwdRow);
		/* passwd ends */
		/* ssn / passwd ends */

		scrollView.add(loginPrefView);

		/* remember Id starts*/

		var rememberView = ingrs.auth.ui.createCustomTableView({
			top : 19,
			height : 44
		});

		var rememberRow = ingrs.auth.ui.createCustomRowView({
			_showEndLine : false
		});

		var rememberLabel = ingrs.auth.ui.createLabel({
			left : '3.1%',
			text : 'Remember Me',
			color : '#363636'
		});

		var rememberSwitch = Ti.UI.createSwitch({
			style : ingrs.isAndroid() ? Titanium.UI.Android.SWITCH_STYLE_CHECKBOX : '',
			right : '3.1%',
			height : 44,
			value : true
		});

		rememberRow.add(rememberLabel);
		rememberRow.add(rememberSwitch);

		rememberView.add(rememberRow);

		scrollView.add(rememberView);
		/* remember ends starts*/

		loginWindow.resetWindow = function() {
			passwdValue.value = '';
			userTypeValue.value = '';
			userTypeMask.text = '';
			prefRowL2.text = 'Username';
			prefRowL2.textid = 'UNAME';
			userTypeValue.hintText = 'Username';
			rememberSwitch.enabled = true;
			rememberSwitch.value = true;
			userTypeValue.keyboardToolbar = null;
			userTypeValue.keyboardToolbarColor = null;
			userTypeValue.keyboardToolbarHeight = null;
			userTypeValue.keyboardType = Ti.UI.KEYBOARD_DEFAULT;
			ingrs.auth.loginPref.populateSavedPref(prefRowL2, userTypeValue, userTypeMask, rememberSwitch);
			focusField();
		}
		//populate saved preferences
		ingrs.auth.loginPref.populateSavedPref(prefRowL2, userTypeValue, userTypeMask, rememberSwitch);

		/* login button starts*/
		var loginBtn = ingrs.auth.ui.createLoginBtn();

		loginBtn.addEventListener('click', function() {
			var data = {
				participantId : "010507812",
				pin : "wq895623",
				useridtype : "SSN"
			}

			ingrs.auth.authenticateUser({
				data : data
			});

		});

		scrollView.add(loginBtn);

		/* login button ends*/

		scrollView.add(ingrs.auth.ui.createFooterlabel1());

		scrollView.add(ingrs.auth.ui.createFooterlabel2());

		loginWindow.add(scrollView);
		//loginWindow.add(navGroup);
		ingrs.auth.blurFields = function() {
			if(ingrs.isIphone()) {
				userTypeValue.blur();
				passwdValue.blur();
			}
		}
		/* call that validates the user input*/
		function validateFields() {
			return ingrs.auth.validate.validateLoginInput({
				_loginType : prefRowL2.text,
				_userId : userTypeValue.value,
				_password : passwdValue.value
			});
		}


		loginWindow.addEventListener('open', function() {
			loginWindow.orientationModes = [
     Titanium.UI.PORTRAIT,
     Titanium.UI.LANDSCAPE_LEFT,
     Titanium.UI.LANDSCAPE_RIGHT
 ];
			focusField();
		});
		function focusField() {
			if(rememberSwitch.value === true && (userTypeValue.value !== null && userTypeValue.value.trim() !== '')) {
				passwdValue.focus();
			} else {
				userTypeValue.focus();
			}
		}

		return loginWindow;
	};
	/* method that is used to authenticate user*/
	ingrs.auth.authenticateUser = function(params) {
		response = {
			"brandHeaderType" : "I",
			"challengeResult" : null,
			"deviceRegistered" : false,
			"employerName" : null,
			"homePageMsg" : "MSG:MobileHomepageMsg",
			"loginResponse" : {
				"authMessage" : null,
				"authResult" : "login_sucess",
				"clientId" : "INGWIN",
				"clientList" : [],
				"cssessionId" : "xN3b0pfluc2rvwlzqk21KQ--.I604",
				"deviceRegistered" : true,
				"domain" : "ingretirement.intg.ingplans.com",
				"informationLine" : "1-800-584-6001"
			},
			"partName" : "ERIC MONTE-DP",
			"planBeanList" : [{
				"asOfDate" : "DEC 7, 2011",
				"balance" : "$7,786.19",
				"planId" : "776991",
				"planName" : "ING AMERICAS SAVINGS PLAN LLC & WWWWWWWWWWWWWWW LLC & ESOP & LTD",
				"planType" : "SAVINGS"
			}]
		};
		authResult = 'login_success';

		ingrs.auth.createAcntSummaryWin().open();

		function processSuccessfulResponse(_response) {
			ingrs.auth.cssessionid = _response.cssessionId;
			ingrs.auth.selectedClient = _response.clientId;
			ingrs.net.domain = _response.domain;
			ingrs.auth.deviceRegistered = _response.deviceRegistered;
			ingrs.auth.clientInformationLine = _response.informationLine;
		}

	};
	
	 var activityIndicator = Titanium.UI.createActivityIndicator({
                    height:'100%',
                    width:'100%',
                    message:'Loading...',
                    font:{size:8},
                    color:'white',
                    style:Titanium.UI.iPhone.ActivityIndicatorStyle.PLAIN
                });
       var activityView = Ti.UI.createView({
                    zIndex:'-1',
                    height:100,
                    width:'31.25%',
                    borderRadius:10,
                    backgroundColor:'black'
                });
        var activityWindow = Ti.UI.createWindow({
        			width:'100%',
        			height:'100%'
        		});
        activityView.add(activityIndicator);
        activityWindow.add(activityView);
 function showActivityIndicator() {
            activityIndicator.show();
            if (ingrs.isIphone()) {
            	activityWindow.open();
                /*_win.touchEnabled = false;
                _win.opacity = 0.8;
                _win.add(activityView);*/
            }
        };
        
        function hideActivityIndicator() {
            activityIndicator.hide();
            if (ingrs.isIphone()) {
            	activityWindow.close();
                /*_win.remove(activityView);
                _win.opacity = 1;
                _win.touchEnabled = true;*/
            }
        };
      
	ingrs.auth.endUserSession = function() {
		var client = Ti.Network.createHTTPClient({
     // function called when the response data is available
     onload : function(e) {
     	hideActivityIndicator()
     },
     // function called when an error occurs, including a timeout
     onerror : function(e) {
     	hideActivityIndicator()
     }
 });
 // Prepare the connection.
 client.open("GET", "http://www.appcelerator.com");
 showActivityIndicator();
 // Send the request.
 client.send();
           
	};

	Ti.App.addEventListener('app:endSession', ingrs.auth.endUserSession);

})();
